function  Floyd_had
    E= 1435;% PSI
    nu=0.49;
    % geometry
    R1= 6;%  inches
    Rf=0.15;% Inches
    R2=R1-0.6;% inches
    L1=3.15;%Inches
    L2=1.5;%Inches
    % prescribed Traction
    Pressure=2.61;%N
    Region_definition={...
        ['curve 1 line ' num2str(0) ' ' num2str(0) ' ' num2str(R1) ' ' num2str(0) ],...
        ['curve 2 line ' num2str(R1) ' ' num2str(0) ' ' num2str(R1) ' ' num2str(L1) ],...
        ['curve 3 line ' num2str(R1) ' ' num2str(L1) ' ' num2str(R2) ' ' num2str(L1) ],...
        ['curve 4 line ' num2str(R2) ' ' num2str(L1) ' ' num2str(R2) ' ' num2str(L2+Rf) ],...
        ['curve 5 arc ' num2str(R2) ' ' num2str(L2+Rf) ' ' num2str(R2-Rf) ' ' num2str(L2) ' center ' num2str(R2-Rf) ' ' num2str(L2+Rf) ],...
        ['curve 6 line ' num2str(R2-Rf) ' ' num2str(L2) ' ' num2str(0) ' ' num2str(L2) ],...
        ['curve 7 line ' num2str(0) ' ' num2str(L2) ' ' num2str(0) ' ' num2str(0) ],...
        ['subregion 1  property 1 boundary 1 2 3 4 5 6 7']};
    Mesh_options =struct('axisymm',true,'quadratic',true);
    Targetnel=600;
    convergence_rate=1.5;
    graphics=1;
    sigj=1;

    % Mesh'
    mesh_size=8/(2^3);
    [fens,gcells,groups,edge_gcells,edge_groups]...
        =targe2_mesher(cat(2,Region_definition,{['m-ctl-point constant ' num2str(mesh_size)]}), 1.0, Mesh_options);
%     drawmesh({fens,gcells},'gcells','facecolor','red');  view(2); return
    
    
    for Adapt=1:3
        
        length(gcells)
        
        % Material
        prop = property_linel_iso (struct('E',E,'nu',nu));
        mater = mater_defor_ss_linel_biax (struct('property',prop, ...
            'reduction','axisymm'));
        % Finite element block
        feb = feblock_defor_ss (struct ('mater',mater, 'gcells',gcells,...
            'integration_rule',tri_rule (6)));
        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 2, 'fens',fens));
        % Define the displacement field
        u   = clone(geom,'u');
        u   = u*0; % zero out
        % Apply EBC's
        ebc_fenids=fenode_select (fens,struct('box',[0 R1 L1 L1],'inflate',L1/1000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_fenids*0+2;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        % The axis of symmetry
        ebc_fenids=fenode_select (fens,struct('box',[0 0 0 L1+L2],'inflate',L1/1000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_prescribed*0+1;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        u   = apply_ebc (u);
        % Number equations
        u   = numbereqns (u);
        % Assemble the system matrix
        K = start(sparse_sysmat, get(u, 'neqns'));
        K = assemble (K, stiffness(feb, geom, u));
        % Load
        F = start (sysvec, get(u, 'neqns'));
        F = assemble (F, nz_ebc_loads(feb, geom, u));
        efeb = feblock_defor_ss (struct ('mater',mater, ...
            'gcells',edge_gcells(edge_groups{4}),...
            'integration_rule',gauss_rule (1, 2)));
        fi=force_intensity(struct('magn',[Pressure;0]));
        F = assemble (F, distrib_loads(efeb, geom, u, fi, 2));
        efeb = feblock_defor_ss (struct ('mater',mater, ...
            'gcells',edge_gcells(edge_groups{5}),...
            'integration_rule',gauss_rule (1, 2)));
        fi=force_intensity(struct('magn',@(x) (Pressure*(x-[R2-Rf,L2+Rf])'/norm((x-[R2-Rf,L2+Rf])))));
        F = assemble (F, distrib_loads(efeb, geom, u, fi, 2));
        efeb = feblock_defor_ss (struct ('mater',mater, ...
            'gcells',edge_gcells(edge_groups{6}),...
            'integration_rule',gauss_rule (1, 2)));
        fi=force_intensity(struct('magn',[0;-Pressure]));
        F = assemble (F, distrib_loads(efeb, geom, u, fi, 2));
        % Solve
        u = scatter_sysvec(u, get(K,'mat')\get(F,'vec'));
        % get(u,'values')
        
        maxP1=-Inf; maxP2=-Inf; maxP3=-Inf;  maxxy=0;
        for q=1:length(gcells)
            conn = get(gcells(q), 'conn');
            x=gather(geom,conn,'values','noreshape');
            Cauchy = inspect_integration_points(feb, geom, u, [], ...
                q, struct ('output','Cauchy'), @idi,  []);
        end
        maxP12d=-Inf; maxP22d=-Inf;  maxxy2d=0;
        for q=1:length(gcells)
            conn = get(gcells(q), 'conn');
            x=gather(geom,conn,'values','noreshape');
            Cauchy = inspect_integration_points(feb, geom, u, [], ...
                q, struct ('output','Cauchy'), @idi2d,  []);
        end
        disp([' Mesh size: ' num2str(mesh_size)]);
        disp([' Location 3d:  [' num2str(maxxy) '],  Principal stresses 3d: [' num2str(maxP1) ',' num2str(maxP2) ',' num2str(maxP3) ']' ]);
        disp([' Location 2d:  [' num2str(maxxy2d) '],  Principal stresses 2d: [' num2str(maxP12d) ',' num2str(maxP22d) ']' ]);
        %     return
        
        nodal_stress = field_from_integration_points_spr(feb, geom, u, [], 'Cauchy', 1:4);
        elerrs = flux_L2_error (feb, geom, u, [], nodal_stress);
        total_err=sqrt(sum(elerrs.^2));
        targeterr=sqrt(total_err^2/Targetnel);
        
        x=get(geom,'values');
        conn=zeros(length(gcells),length(get(gcells(1),'conn')));
        for j=1:length(gcells)
            conn(j,:)=get(gcells(j),'conn');
        end
        [hcurs, hests] =t3_mesh_sizes(conn,x,targeterr,elerrs,convergence_rate);
        
        if (graphics)
            gv=graphic_viewer;
            gv=reset (gv,struct ('limits',[0 1.06*R1 -0.5*L1 1.1*L1]));
            scale=5;
            cmap = jet;
            fld1 = field_from_integration_points(feb, geom, u, [], 'Cauchy',1);
            fld2 = field_from_integration_points(feb, geom, u, [], 'Cauchy',2);
            fld3 = field_from_integration_points(feb, geom, u, [], 'Cauchy',3);
            fld4 = field_from_integration_points(feb, geom, u, [], 'Cauchy',4);
            stresses = [get(fld1,'values'),get(fld2,'values'),get(fld3,'values'),get(fld4,'values')];
            Ps=zeros(size(stresses,1),3);
            maxP1=-Inf;
            for q= 1:size(stresses,1)
                [V,D]=eig(stress_3v_to_2x2t (mater,stresses(q,[1, 2, 4])));
                sD=sort(diag(D),'descend');
                Ps(q,1:2)=sD;Ps(q,3)=stresses(q,3);
            end
            nvals=Ps(:,sigj);%min(nvals),max(nvals)
            nvalsrange=[min(nvals),max(nvals)];
            dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
            colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
            geom3=field(struct ('name', ['geom3'], ...
                'data',[get(geom,'values'),0.*nvals]));
            u3=field(struct ('name', ['u3'], ...
                'data',[get(u,'values'),0*nvals]));
            draw(feb,gv, struct ('x', geom3, 'u', +scale*u3,'colorfield',colorfield, 'edgecolor', 'black','shrink',1.0));
            %     draw(feb,gv, struct ('x', geom3, 'u', +0*u3,'facecolor','none', 'edgecolor','black'));
            draw_colorbar(gv, struct('colormap',cmap,'position',[0.85 0.15 0.05 0.7],...
                'minmax',nvalsrange,'label',['\sigma_{' num2str(sigj) '}']));
        end
        
        
        [fens,gcells,groups,edge_gcells,edge_groups] ...
            = targe2_mesher_adapt(Region_definition,conn,x,hests,1.0,Mesh_options);
    end
    
    function idat=idi(idat, out, xyz, pc)
        [V,D]=eig(stress_4v_to_3x3t (mater,out([1, 2, 4, 3])));
        sD=sort(diag(D),'descend');
        if (sD(1)>=maxP1)
            maxP1=sD(1);
            maxP2=sD(2);
            maxP3=sD(3);
            maxxy=xyz;
            stress_4v_to_3x3t (mater,out);
        end
    end
    function idat=idi2d(idat, out, xyz, pc)
        [V,D]=eig(stress_3v_to_2x2t (mater,out([1, 2, 4])));
        sD=sort(diag(D),'descend');
        if (sD(1)>=maxP12d)
            maxP12d=sD(1);
            maxP22d=sD(2);
            maxxy2d=xyz;
            %              stress_3v_to_2x2t (mater,out([1, 2, 4]))
        end
    end
    
end%
