disp('Taut wire: characteristic frequencies, Two element mesh');
L=20;
P=80;
mu= 80;
neigvs=3;
ns=[2]; % number of elements
% ns=[32]; % number of elements
eigenvalue_errors = zeros(length(ns),neigvs);
% Mesh
for mesh=1:length(ns)
    n=ns(mesh);
    [fens,gcells]= block1d(L,n, 1.0);
    % Finite element block
    feb = feblock_defor_taut_wire(struct ('mater',mater,...
        'gcells',gcells,...
        'integration_rule',gauss_rule(1, 4),...%simpson_1_3_rule,...
        'P',P,'mu',mu));
    % Geometry
    geom = field(struct ('name',['geom'], 'dim', 1, 'fens',fens));
    % Define the displacement field
    w   = 0*clone(geom,'w');
    % Apply EBC's
%     fenids=[1,n+1]; prescribed=[1, 1]; component=[1, 1]; val=[0,0];
%     w   = set_ebc(w, fenids, prescribed, component, val);
%     w   = apply_ebc (w);
    % Number equations
    w   = numbereqns (w, [3,1,2]');
    % Assemble the stiffness matrix
    K = start (sparse_sysmat, get(w, 'neqns'));
    K = assemble (K, stiffness(feb, geom, w));
    % Assemble the consistent mass matrix
    M = start (sparse_sysmat, get(w, 'neqns'));
    M = assemble (M, mass(feb, geom, w));
    % Assemble the lumped mass matrix
%         M = start (sparse_sysmat, get(w, 'neqns'));
%         M = assemble(M, elemat( struct('eqnums', (1:n-1),'mat', eye(n-1) * mu*L/n)));
    % Solve
    [W,Omega]=eig((L/2/P)*full(get(K,'mat')),(12/mu/L)*full(get(M,'mat')));
    [Omegas,ix]=sort(diag(Omega));
%     for i=1:size(W,2)
%         W(:,i)=W(:,i)/(W(:,i)'*get(M,'mat')*W(:,i));
%     end 
    Omegas=Omegas*((12/mu/L)/(L/2/P));
    scale=10;
    for i=1:neigvs
        analyt_eigenvalue =sqrt((P/mu*((i-1)*pi/L) ^ 2));
        eigenvalue_errors(mesh,i) =...
            (sqrt(Omegas(i))-analyt_eigenvalue)/analyt_eigenvalue;
        disp(['  Eigenvector ' num2str(i) ...
            ' eigenvalue ' num2str(sqrt(Omegas(i))) ' versus '...
            num2str(analyt_eigenvalue)]);
        figure;
        w = scatter_sysvec(w, W(:,ix(i)));
        plot (gather (geom, (1:n+ 1),'values')/L, ...
            gather (w, (1:n+ 1),'values'),'ro-','linewidth', 3);
        set(gca,'ylim', [-1,1]*max(max(W )));
        hold on
        labels('$x/L$',['$\phi_' num2str(i) '$'])
        left_handed_axes;% Plotting is consistent with the textbook sign convention
        figure (gcf)
        pause(2); % next eigenvector
% print(gcf,'-depsc','-r300',[mfilename '-' 'phi' num2str(i) ])
% saveeps([mfilename '-' 'phi' num2str(i) ])
    end
end

